local wtMainPanel=nil
--local wtbGold3=nil
local wttCoral=nil
local wttGranit=nil
local wttIskra=nil
local wtbMain=nil
--local wtFilterName={}
local wtIcon=nil
local wtText=nil
local wtScroll=nil
local wtbClose=nil
local wttClose=nil
local Rog=nil
local RogSelected={}

local wtpInfo=nil
local wtbInfo=nil
local wttInfo=nil
local wttInfo1=nil

local Lab=nil
local Cfg=nil
local cfgId=nil

local day=1000*60*60*24
local timezone=1000*60*60*1

local avatarId=nil
local avatarName=nil

------------------------------------------------------
function wtSetPlace(w, place )
	local p=w:GetPlacementPlain()
	for k, v in pairs(place) do	
		p[k]=place[k] or v
	end
	w:SetPlacementPlain(p)
end

function SetWidth(w, newW )
	local Placement = w:GetPlacementPlain()
	Placement.sizeX = math.ceil( newW )
	w:SetPlacementPlain( Placement )
end

function WCD(descr, name, parent, place, show)
	local d1 = mainForm:GetChildChecked( descr, false )
	local d2= d1:GetWidgetDesc()
	local n
	n = mainForm:CreateWidgetByDesc( d2 )
	if name then n:SetName( name ) end
	if parent then parent:AddChild(n) end
	if place then wtSetPlace( n, place ) end
	n:Show( show == true )
	return n
end


function AddButton(caption,text, name, parent, place)
	wtMenu=WCD("descIcon",name,parent,place, true)
	wtMenu:SetBackgroundTexture(common.GetAddonRelatedTexture("ButtonFrame"))
	wtText = WCD( "descText", "FilterText", wtMenu, { alignX = 3, sizeX=0, posX = 30, highPosX = 30, alignY = 3, sizeY=0, posY=0, highPosY=0}, true)
	wtText:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="12"><tip_white><rs class="class"><r name="value"/></rs></tip_white></header>'))
	wtText:SetVal( "value",userMods.ToWString(text))
	if caption then
		wtText = WCD( "descText", "FilterCaption", parent, {alignX = 0, sizeX=place.sizeX, posX = place.posX, highPosX = 0, alignY = 0, sizeY=place.sizeY, posY=place.posY-20, highPosY=0}, true)
		wtText:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="12"><tip_yellow><rs class="class"><r name="value"/></rs></tip_yellow></header>'))
		wtText:SetVal( "value",userMods.ToWString(caption))
	end
end

function ShowInfo(mes)
  wtpInfo=WCD("descPanel1",'InfoPanel',mainForm,{alignX=2, posX=0, highPosX=0, sizeX=300, alignY=2, posY=0,  highPosY=0, sizeY=100 }, true)  
  wttInfo1=WCD( "descText", "TextInfo1", wtpInfo, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=4, sizeY=40, posY=10, highPosY=0,}, true)
  wttInfo1:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="16" outline="1"><rs class="class"><tip_green><r name="value"/></tip_green></rs></header>'))		  
  wttInfo1:SetVal("value", mes)
  wtbInfo=WCD("descButton1",'ShowInfo',wtpInfo,{alignX=2, posX=0, highPosX=0, sizeX=80, alignY=1, posY=0,  highPosY=10, sizeY=30 }, true)	
  wttInfo=WCD( "descText", "TextInfo", wtbInfo, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=3, sizeY=20, posY=0, highPosY=0,}, true)
  wttInfo:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="12" outline="1"><rs class="class"><tip_white>OK</tip_white></rs></header>'))		
end

function AddRog(n)
  local ldate=common.GetLocalDateTime()
  local now=math.floor((ldate.overallMs+timezone)/day)*day
  local s=userMods.FromWString(Lab[n].Name)
  
  local num=GetTableSize(Rog)
  if num>0 then
    table.insert(Rog,{})    
  else
    Rog={[1]={}}
  end 
  num=num+1
    
  local col='white'
  if Lab[n].Date<=now then 
    col='green' 
    if (not wtpInfo) then 
      ShowInfo(GTL('Harvest')) 
    end  
  end
  if not Lab[n].Value then Lab[n].Value=0 end
  
  Rog[num].Id=Lab[n].Id
  
  Rog[num].wtpPanel=WCD("descPanel1",'Panel',nil,{alignX=0, posX=5, highPosX=0, sizeX=375, alignY=0, posY=0,  highPosY=0, sizeY=24 }, true)
  wtScroll:PushBack(Rog[num].wtpPanel)
  
  
  Rog[num].wtpNo=WCD("descPanel1",'NoPanel',Rog[num].wtpPanel,{alignX=0, posX=0, highPosX=0, sizeX=25, alignY=3, posY=0,  highPosY=0, sizeY=40 }, true)
  Rog[num].wttNo=WCD( "descText", 'NoText', Rog[num].wtpNo, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=3, sizeY=20, posY=6, highPosY=0,}, true)
  Rog[num].wttNo:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="12" outline="1"><rs class="class"><tip_'..col..'><r name="value"/></tip_'..col..'></rs></header>'))		
  Rog[num].wttNo:SetVal("value", tostring(n))    
  if userMods.FromWString(Lab[n].Name)==userMods.FromWString(avatarName) then Rog[num].wtpNo:SetBackgroundColor({ r = 0.7; g = 0.7; b = 0.7; a = 1.0 }) end
  
  Rog[num].wtpName=WCD("descPanel1",'NamePanel',Rog[num].wtpPanel,{alignX=0, posX=25, highPosX=0, sizeX=120, alignY=3, posY=0, highPosY=0, sizeY=40 }, true)
  Rog[num].wttName=WCD( "descText", "NameText", Rog[num].wtpName, {alignX=3, sizeX=0, posX=15, highPosX=0, alignY=3, sizeY=20, posY=6, highPosY=0,}, true)
  Rog[num].wttName:SetFormat(userMods.ToWString('<header alignx = "left" fontsize="12" outline="1"><rs class="class"><tip_'..col..'><r name="value"/></tip_'..col..'></rs></header>'))		
  Rog[num].wttName:SetVal("value", Lab[n].Name)
  if userMods.FromWString(Lab[n].Name)==userMods.FromWString(avatarName) then Rog[num].wtpName:SetBackgroundColor({ r = 0.7; g = 0.7; b = 0.7; a = 1.0 }) end
  
  Rog[num].wtpType=WCD("descPanel1",'NamePanel',Rog[num].wtpPanel,{alignX=0, posX=145, highPosX=0, sizeX=80, alignY=3, posY=0,  highPosY=0, sizeY=40 }, true)
  Rog[num].wttType=WCD( "descText", "NameText", Rog[num].wtpType, {alignX=3, sizeX=0, posX=15, highPosX=0, alignY=3, sizeY=20, posY=6, highPosY=0,}, true)
  Rog[num].wttType:SetFormat(userMods.ToWString('<header alignx = "left" fontsize="12" outline="1"><rs class="class"><tip_'..col..'><r name="value"/></tip_'..col..'></rs></header>'))		
  Rog[num].wttType:SetVal("value", GTL(Lab[n].Type))
  if userMods.FromWString(Lab[n].Name)==userMods.FromWString(avatarName) then Rog[num].wtpType:SetBackgroundColor({ r = 0.7; g = 0.7; b = 0.7; a = 1.0 }) end
  
  Rog[num].wtpVal=WCD("descPanel1",'NamePanel',Rog[num].wtpPanel,{alignX=0, posX=225, highPosX=0, sizeX=80, alignY=3, posY=0,  highPosY=0, sizeY=40 }, true)
  Rog[num].wttVal=WCD( "descText", "NameText", Rog[num].wtpVal, {alignX=3, sizeX=0, posX=0, highPosX=15, alignY=3, sizeY=20, posY=6, highPosY=0,}, true)
  Rog[num].wttVal:SetFormat(userMods.ToWString('<header alignx = "right" fontsize="12" outline="1"><rs class="class"><tip_'..col..'><r name="value"/></tip_'..col..'></rs></header>'))		
  Rog[num].wttVal:SetVal("value", tostring(Lab[n].Value))
  if userMods.FromWString(Lab[n].Name)==userMods.FromWString(avatarName) then Rog[num].wtpVal:SetBackgroundColor({ r = 0.7; g = 0.7; b = 0.7; a = 1.0 }) end

  Rog[num].wtpDays=WCD("descPanel1",'NamePanel',Rog[num].wtpPanel,{alignX=0, posX=305, highPosX=0, sizeX=45, alignY=3, posY=0,  highPosY=0, sizeY=40 }, true)
  Rog[num].wttDays=WCD( "descText", "NameText", Rog[num].wtpDays, {alignX=3, sizeX=0, posX=0, highPosX=15, alignY=3, sizeY=20, posY=6, highPosY=0,}, true)
  Rog[num].wttDays:SetFormat(userMods.ToWString('<header alignx = "right" fontsize="12" outline="1"><rs class="class"><tip_'..col..'><r name="value"/></tip_'..col..'></rs></header>'))		
  Rog[num].wttDays:SetVal("value", tostring((Lab[n].Date-now)/day))
  if userMods.FromWString(Lab[n].Name)==userMods.FromWString(avatarName) then Rog[num].wtpDays:SetBackgroundColor({ r = 0.7; g = 0.7; b = 0.7; a = 1.0 }) end

  Rog[num].wtpDel=WCD("descPanel1",'DelButton',Rog[num].wtpPanel,{alignX=0, posX=350, highPosX=0, sizeX=25, alignY=3, posY=0,  highPosY=0, sizeY=40 }, true)
  Rog[num].wttDel=WCD( "descText", 'DelButton', Rog[num].wtpDel, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=3, sizeY=20, posY=6, highPosY=0,}, true)
  Rog[num].wtiDel=WCD( "descIcon", 'RogDel_'..Lab[n].Id, Rog[num].wtpDel, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=3, sizeY=20, posY=6, highPosY=0,}, true)  
  Rog[num].wttDel:SetFormat(userMods.ToWString('<header alignx = "Center" fontsize="12" outline="1"><rs class="class"><tip_red><r name="value"/></tip_red></rs></header>'))		
  Rog[num].wttDel:SetVal("value", 'X')
  
  -- if userMods.FromWString(Lab[n].Name)==userMods.FromWString(avatarName) then 
     -- Lab[n].wtbRogDel=WCD("descButton",'rogDel_'..Lab[n].Id,wtMainPanel,{alignX=0, posX=310, highPosX=0, sizeX=20, alignY=0, posY=60+25*rogs,  highPosY=0, sizeY=20 }, true)	
     -- Lab[n].wtbText=WCD( "descText", "Text", Lab[n].wtbRogDel, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=0, sizeY=20, posY=8, highPosY=0,}, true)
     -- Lab[n].wtbText:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="10" outline="1"><rs class="class"><tip_red><r name="value"/></tip_red></rs></header>'))		
     -- Lab[n].wtbText:SetVal("value", 'X')  
    
    -- Lab[n].wtbRogOne=WCD("descButton",'rogOne_'..Lab[n].Id,wtMainPanel,{alignX=0, posX=335, highPosX=0, sizeX=20, alignY=0, posY=60+25*rogs,  highPosY=0, sizeY=20 }, true)	
    -- Lab[n].wtbText1=WCD( "descText", "Text", Lab[n].wtbRogOne, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=0, sizeY=20, posY=8, highPosY=0,}, true)
    -- Lab[n].wtbText1:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="10" outline="1"><rs class="class"><tip_green><r name="value"/></tip_green></rs></header>'))		
    -- Lab[n].wtbText1:SetVal("value", '-1')
  -- end
  --rogs=rogs+1
end

function DelRog(n)
  for i=1, GetTableSize(Rog) do
    if Rog[i].Id==Lab[n].Id then
      Rog[i].wttNo:DestroyWidget()
      Rog[i].wttNo=nil
      Rog[i].wtpNo:DestroyWidget()
      Rog[i].wtpNo=nil
      Rog[i].wttName:DestroyWidget()
      Rog[i].wttName=nil
      Rog[i].wtpName:DestroyWidget()
      Rog[i].wtpName=nil
      Rog[i].wttType:DestroyWidget()
      Rog[i].wttType=nil
      Rog[i].wtpType:DestroyWidget()
      Rog[i].wtpType=nil      
      Rog[i].wttVal:DestroyWidget()
      Rog[i].wttVal=nil
      Rog[i].wtpVal:DestroyWidget()
      Rog[i].wtpVal=nil      
      Rog[i].wttDays:DestroyWidget()
      Rog[i].wttDays=nil
      Rog[i].wtpDays:DestroyWidget()
      Rog[i].wtpDays=nil      
      Rog[i].wtpPanel:DestroyWidget()
      Rog[i].wtpPanel=nil      
      break
    end
  end

  table.remove(Lab,n)      
end

--OnClick
function OnButtonClick(param)
  local num=0
  local ldate=common.GetLocalDateTime()  
  local now=math.floor((ldate.overallMs+timezone)/day)*day
  
  if param.sender=='ShowForm' then
    if (wtMainPanel:IsVisible()) then 
      wtMainPanel:Show(false)
    else
      wtMainPanel:Show(true)
    end  		
  elseif param.sender=='ShowInfo' then
    wttInfo:DestroyWidget()
    wttInfo=nil
    wttInfo1:DestroyWidget()
    wttInfo1=nil
    wtbInfo:DestroyWidget()
    wtbInfo=nil
    wtpInfo:DestroyWidget()
    wtpInfo=nil    
	
  
  -- if param.sender=='Gold3' then
    -- num=0
    -- if Lab then num=GetTableSize(Lab) end
    -- if num>0 then
      -- for i=1, num do
        -- if (userMods.FromWString(Lab[i].Name)==userMods.FromWString(avatarName)) and (Lab[i].Type=="Gold") then 
          -- Lab[i].Date=Lab[i].Date22*day
          -- for j=1, GetTableSize(Rog) do
            -- if Rog[j].Id==Lab[i].Id then
              -- Rog[j].wttDays:SetVal("value", tostring((Lab[i].Date-now)/day))
              -- break
            -- end
          -- end  
        -- end
      -- end
      -- userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)       
    -- end
    
  -- elseif  string.find(param.sender,'rogOne_') then
    -- num=tonumber(string.sub(param.sender,8))
    -- for i=1, GetTableSize(Lab) do
      -- if Lab[i].Id==num then
        -- if Lab[i].Date<=now then Lab[i].Date=now+15*day
        -- else Lab[i].Date=Lab[i].Date-day
        -- end  
        -- --Lab[i].wtText:SetVal("value", tostring(i)..". "..userMods.FromWString(Lab[i].Name).." "..Lab[i].Type.." "..tostring((Lab[i].Date-now)/day))
        -- userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)
        -- break
      -- end
    -- end

    elseif string.find(param.sender,'RogDel_') then
      num=tonumber(string.sub(param.sender,8))
      for i=1, GetTableSize(Lab) do
        if Lab[i].Id==num then
          DelRog(i)
          userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)
          break
        end
      end
    end
end

function CheckRog()
  local ldate=common.GetLocalDateTime()  
  local now=math.floor((ldate.overallMs+timezone)/day)*day    
  local found=false
  
  for i=1, GetTableSize(Lab) do       
    if (userMods.FromWString(Lab[i].Name)==userMods.FromWString(avatarName)) and (Lab[i].Type==RogSelected.Type) and (Lab[i].Value==RogSelected.Value) 
    and (((Lab[i].Date-now)/day==RogSelected.Days) or ((RogSelected.Days==0) and ((Lab[i].Date-now)/day<0)))
    then
      found=true
      break
    end
  end

  local broken=false
  if not found then
    for i=1, GetTableSize(Lab) do       
      if (userMods.FromWString(Lab[i].Name)==userMods.FromWString(avatarName)) and (Lab[i].Type==RogSelected.Type) and (Lab[i].Value==RogSelected.Value) 
        and ((Lab[i].Date-now)/day+2==RogSelected.Days)
      then
        found=true
        broken=true
        break
      end
    end  
  end

  -- +2 
  if found and broken then
    for i=1, GetTableSize(Lab) do
      if (userMods.FromWString(Lab[i].Name)==userMods.FromWString(avatarName)) and (Lab[i].Type==RogSelected.Type) then 
        Lab[i].Date=Lab[i].Date+2*day
        for j=1, GetTableSize(Rog) do
          if Rog[j].Id==Lab[i].Id then
            Rog[j].wttDays:SetVal("value", tostring((Lab[i].Date-now)/day))
            break
          end
        end  
      end
    end
    userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)         
  end
  
  if not found then
    local num=0
    if Lab then num=GetTableSize(Lab) end

    local slab={Name=avatarName,Type=RogSelected.Type,Date=now+RogSelected.Days*day, Id=ldate.overallMs, Value=RogSelected.Value}
     
    if num>0 then
      table.insert(Lab,slab)
    else
      Lab={[1]=slab}
    end  
    num=num+1
    AddRog(num)     
    userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)  
  end
end

function OnInteract()
  local inter=avatar.GetInteractorInfo()
  if inter then
    
    if (userMods.FromWString(object.GetName(inter.interactorId))==GTL('Bob Jackhammer')) then
      local cue = avatar.GetInteractorNextCues()    
      if Cfg[cfgId].NeedCoral~=cue[0].data[0].number then
        Cfg[cfgId].NeedCoral=cue[0].data[0].number
        wttCoral:SetVal("val2", tostring(Cfg[cfgId].NeedCoral))
        userMods.SetGlobalConfigSection("LabCalendar_Cfg", Cfg)
      end  
    elseif (userMods.FromWString(object.GetName(inter.interactorId))==GTL('Horn')) then 
      local num=0
      local ldate=common.GetLocalDateTime()  
      local now=math.floor((ldate.overallMs+timezone)/day)*day    
    
      local cue = avatar.GetInteractorNextCues()
      local icue=avatar.GetInteractorCue()
      
      --Debug
      if 1==2 then
        LogInfo('Info:')
        LogInfo(icue.name)
        LogInfo(icue.text)

        if icue.data then
          LogInfo('<')
          for k, Idk in pairs(icue.data) do
            LogInfo(k)
            LogInfo(icue.data[k].alias)
            if icue.data[k].number then 
              LogInfo('Number: '..tostring(icue.data[k].number))
            end  
            if icue.data[k].money then 
              LogInfo('Money: '..tostring(icue.data[k].money))
            end              
            if icue.data[k].itemId then 
              LogInfo('ItemId: '..userMods.FromWString(icue.data[k].itemId))
            end  
            if icue.data[k].string then 
              LogInfo('String: '..userMods.FromWString(icue.data[k].string))
            end              
            LogInfo('---')
          end
          LogInfo('>')
        end
      
        LogInfo(' ')
        
        LogInfo('Cues:')
        for j, Id in pairs(cue) do
          LogInfo(j)
          LogInfo('Name: '..userMods.FromWString(cue[j].name))
          LogInfo('Text: '..userMods.FromWString(cue[j].text))
          if cue[j].data then
            LogInfo('<')
            for k, Idk in pairs(cue[j].data) do
              LogInfo(k)
              LogInfo(cue[j].data[k].alias)
              if cue[j].data[k].number then 
                LogInfo('Number: '..tostring(cue[j].data[k].number))
              end  
              if cue[j].data[k].money then 
                LogInfo('Money: '..tostring(cue[j].data[k].money))
              end              
              if cue[j].data[k].itemId then 
                LogInfo('ItemId: '..userMods.FromWString(cue[j].data[k].itemId))
              end  
              if cue[j].data[k].string then 
                LogInfo('String: '..userMods.FromWString(cue[j].data[k].string))
              end              
              LogInfo('---')
            end
            LogInfo('>')
          end
          LogInfo('--------')
        end
        LogInfo('========')
      end      
      --Rog +
      if string.find(userMods.FromWString(icue.name),GTL('Produce Gold')) then
        --LogInfo('Start money: '..tostring(icue.data[0].number))
        if Lab then num=GetTableSize(Lab) end
        
        local slab={Name=avatarName,Type="Gold",Date=now+15*day, Id=ldate.overallMs, Value=icue.data[0].number}
        if num>0 then
          table.insert(Lab,slab)
        else
          Lab={[1]=slab}
        end  
        num=num+1
        AddRog(num)     
        userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)
        avatar.StopInteract()
        
      --Rog +
      elseif string.find(userMods.FromWString(icue.name),GTL('Produce Coral')) then
        --LogInfo('Start money: '..tostring(icue.data[0].number))
        if Lab then num=GetTableSize(Lab) end
        
        local slab={Name=avatarName,Type="Coral",Date=now+15*day, Id=ldate.overallMs, Value=icue.data[0].number}
        if num>0 then
          table.insert(Lab,slab)
        else
          Lab={[1]=slab}
        end  
        num=num+1
        AddRog(num)        
        userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)
        avatar.StopInteract()
        
      --Rog +
      elseif string.find(userMods.FromWString(icue.name),GTL('Produce Granit')) then
        --LogInfo('Start money: '..tostring(icue.data[0].number))
        if Lab then num=GetTableSize(Lab) end
        
        local slab={Name=avatarName,Type="Granit",Date=now+15*day, Id=ldate.overallMs, Value=icue.data[0].number}
        if num>0 then
          table.insert(Lab,slab)
        else
          Lab={[1]=slab}
        end  
        num=num+1
        AddRog(num)                
        userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)
        avatar.StopInteract()
       
      --Rog  
      elseif (userMods.FromWString(icue.name)==GTL('Manage Horn')) then
        -- 
        if string.find(userMods.FromWString(icue.text),GTL('Horn Ready')) then
          if RogSelected.Type=='Gold' then avatar.SelectInteractorCue(0) end
          if RogSelected.Type=='Coral' then avatar.SelectInteractorCue(3) end
          if RogSelected.Type=='Granit' then avatar.SelectInteractorCue(3) end
            --if (userMods.FromWString(icue.data[1].string)==' ') avatar.SelectInteractorCue() 
          --end
        --  
        elseif string.find(userMods.FromWString(icue.text),GTL('Horn Busy')) then 
          RogSelected.Days=icue.data[0].number
          if (userMods.FromWString(icue.data[1].string)==GTL('_Gold')) then
            RogSelected.Type='Gold'           
          elseif (userMods.FromWString(icue.data[1].string)==GTL('_Granit')) then
            RogSelected.Type='Granit'
          elseif (userMods.FromWString(icue.data[1].string)==GTL('_Coral')) then
            RogSelected.Type='Coral'            
          end  
          RogSelected.Value=icue.data[2].number
          CheckRog()
        --    
        elseif string.find(userMods.FromWString(icue.text),GTL('Horn Completed')) then 
          RogSelected.Days=0
          if (userMods.FromWString(cue[0].data[0].string)==GTL('_Gold')) then
            RogSelected.Type='Gold'           
          elseif (userMods.FromWString(cue[0].data[0].string)==GTL('_Granit')) then
            RogSelected.Type='Granit'
          elseif (userMods.FromWString(cue[0].data[0].string)==' ') then
            RogSelected.Type='Coral'            
          end  
          RogSelected.Value=cue[0].data[1].number
          CheckRog()
          avatar.SelectInteractorCue(0)          
        --   
        elseif string.find(userMods.FromWString(icue.text),GTL('Horn Broken')) then 
          RogSelected.Days=icue.data[1].number
          if (userMods.FromWString(icue.data[2].string)==GTL('_Gold')) then
            RogSelected.Type='Gold'           
          elseif (userMods.FromWString(icue.data[2].string)==GTL('_Granit')) then
            RogSelected.Type='Granit'
          elseif (userMods.FromWString(icue.data[2].string)==GTL('_Coral')) then
            RogSelected.Type='Coral'            
          end  
          RogSelected.Value=icue.data[3].number          
          CheckRog()
        end
        
      --Rog  
      elseif (userMods.FromWString(icue.text)==GTL('Production Canceled')) or (userMods.FromWString(icue.text)==GTL('Ready for production')) then  
        local found=false
        for i=1, GetTableSize(Lab) do       
          if (userMods.FromWString(Lab[i].Name)==userMods.FromWString(avatarName)) and (Lab[i].Type==RogSelected.Type) and (Lab[i].Value==RogSelected.Value) 
          and (((Lab[i].Date-now)/day==RogSelected.Days) or ((RogSelected.Days==0) and ((Lab[i].Date-now)/day<0)))
          then
            DelRog(i)
            found=true
            userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)
            break
          end
        end
        if not found then
          for i=1, GetTableSize(Lab) do       
            if (userMods.FromWString(Lab[i].Name)==userMods.FromWString(avatarName)) and (Lab[i].Type==RogSelected.Type) and (Lab[i].Value==0)
            and (((Lab[i].Date-now)/day==RogSelected.Days) or ((RogSelected.Days==0) and ((Lab[i].Date-now)/day<0)))
            then
              DelRog(i)
              found=true
              userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)
              break
            end
          end 
        end
        avatar.SelectInteractorCue(0)
              
      --Rog  -1 
      elseif (userMods.FromWString(icue.text)==GTL('Spark Used')) then  
        for i=1, GetTableSize(Lab) do       
          if (userMods.FromWString(Lab[i].Name)==userMods.FromWString(avatarName)) and (Lab[i].Type==RogSelected.Type) and (Lab[i].Value==RogSelected.Value) and ((Lab[i].Date-now)/day==RogSelected.Days)
          then
            Lab[i].Date=Lab[i].Date-day
            userMods.SetGlobalConfigSection("LabCalendar_Data", Lab)
            for j=1, GetTableSize(Rog) do
              if Rog[j].Id==Lab[i].Id then
                Rog[j].wttDays:SetVal("value", tostring((Lab[i].Date-now)/day))
                break
              end
            end
            break
          end
        end 
      end      
    end    
  end  
end

function OnCurrencyChanged(param)
  local info = param.id:GetInfo()
  if info.name then
    if userMods.FromWString(info.name) == GTL('_Coral') then
      Cfg[cfgId].HaveCoral=Cfg[cfgId].HaveCoral+param.delta
      wttCoral:SetVal("val1", tostring(Cfg[cfgId].HaveCoral))
      if (Cfg[cfgId].HaveCoral>=Cfg[cfgId].NeedCoral) and (not wtpInfo) then ShowInfo(GTL('Can Build New')) end
    elseif userMods.FromWString(info.name) == GTL('_Granit') then
      Cfg[cfgId].HaveGranit=Cfg[cfgId].HaveGranit+param.delta
      wttGranit:SetVal("val1", tostring(Cfg[cfgId].HaveCoral))
    elseif userMods.FromWString(info.name) == GTL('_Spark') then
      Cfg[cfgId].HaveIskra=Cfg[cfgId].HaveIskra+param.delta
      wttIskra:SetVal("val1", tostring(Cfg[cfgId].HaveIskra))
    end             
  end
end

function OnInteractEnd()
  RogSelected={}
end

function OnAvatarCreated()
  wtbMain = WCD("descButton",'ShowForm',mainForm,{alignX=0, posX=200, highPosX=0, sizeX=30, alignY=0, posY=20,  highPosY=0, sizeY=30 }, true)	
  wtText=WCD( "descText", "Text", wtbMain, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=0, sizeY=20, posY=8, highPosY=0,}, true)
  wtText:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="12" outline="1"><rs class="class"><tip_white><r name="value"/></tip_white></rs></header>'))		
  wtText:SetVal("value", 'L')
  
  wtMainPanel = WCD("descPanel1",'MainPanel',mainForm,{alignX=0, posX=700, highPosX=0, sizeX=425, alignY=0, posY=200,  highPosY=0, sizeY=400 }, false)
	wtIcon=WCD("descIcon",'Icon',wtMainPanel,{alignX=3, sizeX=220, posX=0, highPosX=0, alignY=3, sizeY=15, posY=0, highPosY=0}, true)

  wtScroll = WCD( "descScroll", "Scroll", wtMainPanel, { alignX = 3, posX = -10, highPosX = 0, sizeX = 0, alignY = 3, posY =30,  highPosY = 40, sizeY = 0 }, true)
  wtbClose=WCD("descButton1",'ShowForm',wtMainPanel,{alignX=2, posX=0, highPosX=0, sizeX=80, alignY=1, posY=0,  highPosY=10, sizeY=30 }, true)	
  wttClose=WCD( "descText", "TextInfo", wtbClose, {alignX=3, sizeX=0, posX=0, highPosX=0, alignY=3, sizeY=20, posY=0, highPosY=0,}, true)
  wttClose:SetFormat(userMods.ToWString('<header alignx = "center" fontsize="12" outline="1"><rs class="class"><tip_white>OK</tip_white></rs></header>'))		  
  
--	WIDGET_ALIGN_HIGH = 1
--	WIDGET_ALIGN_CENTER = 2
--	WIDGET_ALIGN_BOTH = 3
--	WIDGET_ALIGN_LOW = 4	
	
	
  DnD:Init(wtbMain, wtbMain, true)
	DnD:Init(wtIcon, wtMainPanel, true)

  Lab=userMods.GetGlobalConfigSection("LabCalendar_Data")
  
  local num=0
  if Lab then num=GetTableSize(Lab) end
  
	avatarId=avatar.GetId()
  avatarName=object.GetName(avatarId)
  local ldate=common.GetLocalDateTime()
  local now=math.floor((ldate.overallMs+timezone)/day)*day  
  if num>0 then
    for i=1, num do
        AddRog(i) 
    end
  end

  Cfg=userMods.GetGlobalConfigSection("LabCalendar_Cfg") or {}   
  cfgId=1
  if Cfg then
    cfgId=GetTableSize(Cfg)+1
    for i=1, GetTableSize(Cfg) do
      if userMods.FromWString(Cfg[i].Name)==userMods.FromWString(avatarName) then
        cfgId=i
        break
      end
    end
  end
  
  if not Cfg[cfgId] then Cfg[cfgId]={Name=avatarName,NeedCoral=0} end
  wttCoral=WCD( "descText", "Text", wtMainPanel, {alignX=4, sizeX=150, posX=15, highPosX=0, alignY=4, sizeY=20, posY=20, highPosY=0,}, true)
  wttCoral:SetFormat(userMods.ToWString('<header alignx = "left" fontsize="12" outline="1"><rs class="class"><tip_white>' .. GTL('Coral') .. ': <r name="val1"/> / <r name="val2"/></tip_white></rs></header>'))		
  wttCoral:SetVal("val1", '0')
  wttCoral:SetVal("val2", tostring(Cfg[cfgId].NeedCoral))
  
  wttGranit=WCD( "descText", "Text", wtMainPanel, {alignX=4, sizeX=150, posX=150, highPosX=0, alignY=4, sizeY=20, posY=20, highPosY=0,}, true)
  wttGranit:SetFormat(userMods.ToWString('<header alignx = "left" fontsize="12" outline="1"><rs class="class"><tip_white>' .. GTL('Granit') .. ': <r name="val1"/></tip_white></rs></header>'))		
  wttGranit:SetVal("val1", '0')  
  
  wttIskra=WCD( "descText", "Text", wtMainPanel, {alignX=4, sizeX=150, posX=250, highPosX=0, alignY=4, sizeY=20, posY=20, highPosY=0,}, true)
  wttIskra:SetFormat(userMods.ToWString('<header alignx = "left" fontsize="12" outline="1"><rs class="class"><tip_white>' .. GTL('Spark') .. ': <r name="val1"/></tip_white></rs></header>'))		
  wttIskra:SetVal("val1", '0')    
 
	common.UnRegisterEventHandler(OnAvatarCreated,"EVENT_AVATAR_CREATED")  
  common.RegisterReactionHandler(OnButtonClick, "ButtonReaction")
  common.RegisterReactionHandler(OnButtonClick, "IconButtonReaction")
  common.RegisterEventHandler(OnInteract,"EVENT_INTERACTION_STARTED")
  common.RegisterEventHandler(OnCurrencyChanged,"EVENT_CURRENCY_VALUE_CHANGED")
  common.RegisterEventHandler(OnInteractEnd,"EVENT_TALK_STOPPED")
    
  if not Cfg[cfgId].NeedCoral then Cfg[cfgId].NeedCoral=0 end
  Cfg[cfgId].HaveCoral=0
  Cfg[cfgId].HaveGranit=0
  Cfg[cfgId].HaveIskra=0
  
	--    -------------------------------------------------------------
	local Categorys  = avatar.GetCurrencyCategories()
	for i, CategoryId in pairs(Categorys) do
		local CategoryName = userMods.FromWString(CategoryId:GetInfo().name)
					
		--      ---------------------------------------
		local Currencies = avatar.GetCategoryCurrencies( CategoryId )
		for j, CurrencyId in pairs(Currencies) do

			--       -------------------------------------------------
      local info = CurrencyId:GetInfo()
      local values = avatar.GetCurrencyValue(CurrencyId)
			if info.name then
			  if userMods.FromWString(info.name) == GTL('_Coral') then
          Cfg[cfgId].HaveCoral=values.value
          wttCoral:SetVal("val1", tostring(Cfg[cfgId].HaveCoral))
        end
			  if userMods.FromWString(info.name) == GTL('_Granit') then
          Cfg[cfgId].HaveGranit=values.value
          wttGranit:SetVal("val1", tostring(Cfg[cfgId].HaveGranit))
        end
			  if userMods.FromWString(info.name) == GTL('_Spark') then
          Cfg[cfgId].HaveIskra=values.value
          wttIskra:SetVal("val1", tostring(Cfg[cfgId].HaveIskra))
        end        
			end
		end  
  end  
   
end


--------------------------------------------------------------------------------

-- INITIALIZATION
function Init()
  common.RegisterEventHandler(OnAvatarCreated,"EVENT_AVATAR_CREATED")
	if avatar.IsExist() then OnAvatarCreated() end
end
--------
Init()
--------